/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast.sessops.structuralops;

import polyglot.ast.*;
import polyglot.util.Position;

public class SJInwhile_c extends While_c implements SJInwhile
{
	public SJInwhile_c(Position pos, Expr cond, Stmt body)
	{
		super(pos, cond, body);
	}

	public SJInwhile cond(Expr cond)
	{
		return (SJInwhile) super.cond(cond);
	}

	public SJInwhile body(Stmt body)
	{
		return (SJInwhile) super.body(body);
	}

	// Is it actually necessary to override this method?
	protected SJInwhile_c reconstruct(Expr cond, Stmt body)
	{
		if (cond != this.cond || body != this.body)
		{
			SJInwhile_c n = (SJInwhile_c) copy();

			n.cond = cond;
			n.body = body;

			return n;
		}

		return this;
	}
}
