/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast.sessops.structuralops;

import java.util.List;

import polyglot.ast.*;
import polyglot.util.Position;

import sj.util.SJLabel;

public class SJOutbranch_c extends Block_c implements SJOutbranch
{
	private SJLabel lab;

	public SJOutbranch_c(Position pos, List<Stmt> statements, SJLabel lab)
	{
		super(pos, statements);

		this.lab = lab;
	}

	public SJLabel label()
	{
		return lab;
	}

	// Should set entry point to the socket operation for flow graph building. This is common for all structural operations.
}
