/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.ast.typenodes;

import polyglot.util.Position;

import sj.util.SJLabel;

import static sj.SJConstants.*;

public class SJBranchCaseNode_c extends SJTypeNode_c implements SJBranchCaseNode
{
	private SJLabel lab;
	private SJTypeNode sjTypeNode;

	public SJBranchCaseNode_c(Position pos, SJLabel lab, SJTypeNode sjTypeNode)
	{
		super(pos);

		this.lab = lab;
		this.sjTypeNode = sjTypeNode;
	}

	public SJLabel label()
	{
		return lab;
	}

	public SJTypeNode sjTypeNode()
	{
		return sjTypeNode;
	}

	public SJBranchCaseNode sjTypeNode(SJTypeNode sjTypeNode)
	{
		this.sjTypeNode = sjTypeNode;

		return this;
	}

	public String nodeToString()
	{
		return lab + SJ_STRING_LABEL + " " + sjTypeNode;
	}
}
