/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.del;

import java.util.*;

import polyglot.ast.*;
import polyglot.types.*;
import polyglot.visit.*;

import sj.ast.sessops.*;
import sj.util.*;

public class SJSpawnDel_c extends JL_c implements SJSpawnDel
{
	public Node typeCheck(TypeChecker tc) throws SemanticException
	{
		SJTypeBuilder sjtb = new SJTypeBuilder(tc.job(), tc.typeSystem(), tc.nodeFactory());
		Context context = tc.context();

		SJSpawn sjs = (SJSpawn) node();

		/*New target = sjs.target();

		List sockets = target.arguments();
		List visited = new ArrayList();

		for (Object socket : sockets)
		{
			visited.add(sjtb.buildTypes(context, (Receiver) socket));
		}

		sjs = (SJSpawn) sjs.target((New) target.arguments(visited));*/

		List<Receiver> socketArgs = SJCompilerUtils.getSJSpawnArgs(sjs);
		List<Receiver> visited = new ArrayList<Receiver>();

		for (Object socket : socketArgs)
		{
			visited.add((Receiver) sjtb.buildTypes(context, (Receiver) socket));
		}

		sjs = SJCompilerUtils.setSJSpawnArgs(sjs, visited);

		return sjs.typeCheck(tc); // Still typecheck node as originally intended.
	}
}
