/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.extension;

import java.util.*;

import polyglot.ast.*;

import sj.ast.SJCall;
import sj.ast.sessops.SJSessionOperation;
import sj.ast.sessvars.SJLocalSocket;
import sj.types.typeobjects.typeableinstances.SJMethodInstance;

public class SJCallExt_c extends Ext_c implements SJCallExt
{
	//private List socketArgs;
	private String returned;
	private SJMethodInstance sjmi;

	public List<SJLocalSocket> socketArgs()
	{
		//return socketArgs;

		List args = ((SJCall) node()).arguments();
		List<SJLocalSocket> socketArgs = new ArrayList<SJLocalSocket>();

		for (Object arg : args)
		{
			if (arg instanceof SJLocalSocket) // Parsed by SJSessionOperationParser.
			{
				socketArgs.add((SJLocalSocket) arg);
			}
			else if (arg instanceof SJSessionOperation || arg instanceof SJCall)
			{
				throw new RuntimeException("(Anonymous) session-return not done yet: " + arg);
			}
		}

		return socketArgs;
	}

	/*public SJCall socketArgs(List socketArgs)
	{
		this.socketArgs = socketArgs;

		return (SJCall) node();
	}*/

	public boolean anonymousReturn() // Maybe useless, not usable until after SJTypeChecker pass.
	{
		return (returned() == null && sjMethodInstance().sjReturnType() != null);
	}

	public String returned()
	{
		return returned;
	}

	public SJCall returned(String returned)
	{
		this.returned = returned;

		return (SJCall) node();
	}

	public SJMethodInstance sjMethodInstance()
	{
		return sjmi;
	}

	public SJCall sjMethodInstance(SJMethodInstance sjmi)
	{
		this.sjmi = sjmi;

		return (SJCall) node();
	}
}
