/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.extension;

import java.util.List;

import polyglot.ast.ExtFactory;
import polyglot.ast.Receiver;

import sj.ast.typenodes.SJTypeNode;
import sj.extension.protocoldecls.*;
import sj.extension.createops.*;
import sj.extension.sessops.*;
import sj.extension.sessops.basicops.*;
import sj.extension.sesscasts.*;
import sj.extension.sessformals.*;

public interface SJExtFactory extends ExtFactory
{
	public SJNamedExt SJNamedExt();
	public SJProtocolDeclExt SJProtocolDeclExt(SJTypeNode sjTypeNode);
	public SJCreateOperationExt SJCreateOperationExt();
	public SJSessionTryExt SJSessionTryExt();
	public SJBasicOperationExt SJBasicOperationExt();
	public SJReturnOperationExt SJReturnOperationExt();
	public SJStructuralOperationExt SJStructuralOperationExt(Receiver socket);
	public SJServerOperationExt SJServerOperationExt();
	public SJTypeCastExt SJTypeCastExt();
	public SJTypeFormalExt SJTypeFormalExt(SJTypeNode sjTypeNode);
	public SJMethodDeclExt SJMethodDeclExt();
	public SJCallExt SJCallExt();
	public SJSpawnExt SJSpawnExt(List<Receiver> sockets);
}
