/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.extension;

import java.util.*;

import polyglot.ast.*;

import sj.ast.typenodes.SJTypeNode;
import sj.extension.protocoldecls.*;
import sj.extension.createops.*;
import sj.extension.sessops.*;
import sj.extension.sessops.basicops.*;
import sj.extension.sesscasts.*;
import sj.extension.sessformals.*;

public class SJExtFactory_c extends AbstractExtFactory_c implements SJExtFactory
{
	public SJExtFactory_c()
	{
		super();
	}

	public SJNamedExt SJNamedExt()
	{
		return new SJNamedExt_c();
	}

	public SJProtocolDeclExt SJProtocolDeclExt(SJTypeNode sjTypeNode)
	{
		return new SJProtocolDeclExt_c(sjTypeNode);
	}

	public SJCreateOperationExt SJCreateOperationExt()
	{
		return new SJCreateOperationExt_c();
	}

	public SJSessionTryExt SJSessionTryExt()
	{
		return new SJSessionTryExt_c();
	}

	public SJBasicOperationExt SJBasicOperationExt()
	{
		return new SJBasicOperationExt_c();
	}

	public SJReturnOperationExt SJReturnOperationExt()
	{
		return new SJReturnOperationExt_c();
	}

	public SJStructuralOperationExt SJStructuralOperationExt(Receiver socket)
	{
		return new SJStructuralOperationExt_c(socket);
	}

	public SJServerOperationExt SJServerOperationExt()
	{
		return new SJServerOperationExt_c();
	}

	public SJTypeCastExt SJTypeCastExt()
	{
		return new SJTypeCastExt_c();
	}

	public SJTypeFormalExt SJTypeFormalExt(SJTypeNode sjTypeNode)
	{
		return new SJTypeFormalExt_c(sjTypeNode);
	}

	public SJMethodDeclExt SJMethodDeclExt()
	{
		return new SJMethodDeclExt_c();
	}

	public SJCallExt SJCallExt()
	{
		return new SJCallExt_c();
	}

	public SJSpawnExt SJSpawnExt(List<Receiver> sockets)
	{
		return new SJSpawnExt_c(sockets);
	}
}
