/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.extension.protocoldecls;

import sj.ast.protocoldecls.SJProtocolDecl;
import sj.ast.typenodes.SJTypeNode;
import sj.extension.*;
import sj.types.typeobjects.typeableinstances.SJNamedInstance;

public interface SJProtocolDeclExt extends SJNamedExt
{
	// The SJType is recorded in the SJTypeableExt component after the SJTypeNode has been "parsed" and type-built.
	public SJTypeNode sjTypeNode();
	public SJProtocolDecl sjTypeNode(SJTypeNode sjTypeNode);

	public SJProtocolDecl sjTypeableName(String sjTypeableName); // These refinements (return type) may not be that useful.

	public SJProtocolDecl sjNamedInstance(SJNamedInstance sjni); // The name setter seems never used. However, the instance object setter is needed. But because we are currently using a bunch of generalised static getters/setters in SJCompilerUtils for convenience, we end up having to (re)do the casts that these overridden (refined) setters are supposed to avoid anyway.
}
