/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.types.typeobjects.sesstypes;

import polyglot.types.SemanticException;
import polyglot.types.TypeSystem;

import static sj.SJConstants.SJ_STRING_BEGIN;

public class SJBeginType_c extends SJType_c implements SJBeginType
{
	public static final long serialVersionUID = 1L;

	public SJBeginType_c(TypeSystem ts)
	{
		super(ts);
	}

	public boolean nodeEquals(SJType sjType)
	{
		return (sjType == null) ? false : (sjType instanceof SJBeginType);
	}

	public boolean nodeSubtype(SJType sjType)
	{
		return (sjType == null) ? false : (sjType instanceof SJBeginType);
	}

	public boolean nodeDualtype(SJType sjType)
	{
		return (sjType == null) ? false : (sjType instanceof SJBeginType);
	}

	// Could refine the return types for this and nodeClone, but not very useful.
	public SJType nodeSubsume(SJType sjType) throws SemanticException
	{
		if (!(sjType instanceof SJBeginType))
		{
			throw new SemanticException("Not subsumable: " + this + ", " + sjType);
		}

		return typeSystem().SJBeginType();
	}

	public boolean nodeWellFormed()
	{
		return false;
	}

	public SJType nodeClone()
	{
		return typeSystem().SJBeginType();
	}

	public String nodeToString()
	{
		return SJ_STRING_BEGIN;
	}
}
