/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.types.typeobjects.typeableinstances;

import polyglot.util.Position;

import sj.types.SJTypeSystem;
import sj.types.typeobjects.SJTypeObject_c;
import sj.types.typeobjects.sesstypes.SJType;

public class SJTypeableInstance_c extends SJTypeObject_c implements SJTypeableInstance
{
	public static final long serialVersionUID = 1L;

	private SJType sjType;

	protected SJTypeableInstance_c()
	{
		super();
	}

	public SJTypeableInstance_c(SJTypeSystem ts, Position pos, SJType sjType) // What's the point of pos?
	{
		super(ts, pos);

		sjType(sjType);
	}

	public SJType sjType()
	{
		return (sjType == null) ? null : sjType.treeClone();
	}

	public SJTypeableInstance sjType(SJType sjType)
	{
		this.sjType = (sjType == null) ? null : sjType.treeClone();

		return this;
	}
}
