/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.util;

import java.io.Serializable;

// Immutable.
public final class SJLabel implements Cloneable, Serializable // Serializable hack - fix translation.
{
	public static final long serialVersionUID = 1L;

	private final String lab;

	public SJLabel(String lab)
	{
		this.lab = lab;
	}

	public final String labelValue()
	{
		return lab;
	}

	public final String toString()
	{
		return labelValue();
	}

	public final boolean equals(Object obj)
	{
		if (obj instanceof SJLabel)
		{
			return labelValue().equals(((SJLabel) obj).labelValue());
		}
		else
		{
			return false;
		}
	}

	public final int hashCode()
	{
		return labelValue().hashCode();
	}

	public final SJLabel clone()
	{
		//return new SJLabel(new String(lab));
		return new SJLabel(lab);
	}
}
