/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.visit.contexts;

import java.util.*;

import polyglot.types.*;

import sj.types.typeobjects.sesstypes.SJType;
import sj.types.typeobjects.typeableinstances.*;

public interface SJClassContext extends SJContextElement // Based on the Polyglot ClassType (which is a TypeObject, but we don't treat "session-contexts" or have special class instance objects so information is directly recorded here).
{
	public Set<SJMethodInstance> sjMethods(); // Record recursive methods here or separately?

	public void addSJMethod(SJMethodInstance sjmi); // Only session-methods (rename).
	public void addSJThread(SJThreadInstance sjti);	// This should be generalised to record all inner class members (will be needed for cross method-call if non-private session methods allowed).

	public SJMethodInstance findSJMethod(String name, List<SJType> argTypes) throws SemanticException;
	public SJThreadInstance findSJThread(String name) throws SemanticException;
}
