/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.visit.contexts;

import java.util.*;

import polyglot.types.*;

import sj.types.typeobjects.sesstypes.SJType;
import sj.types.typeobjects.typeableinstances.*;
import sj.util.*;

public class SJClassContext_c extends SJContextElement_c implements SJClassContext
{
	private Set<SJMethodInstance> sjMethods = new HashSet<SJMethodInstance>();
	private Set<SJThreadInstance> sjThreads = new HashSet<SJThreadInstance>();

	public SJClassContext_c()
	{

	}

	/*public SJClassContext_c(Set<SJMethodInstance> sjMethods)
	{
		this.sjMethods = sjMethods;
	}*/

	public Set<SJMethodInstance> sjMethods()
	{
		return sjMethods;
	}

	public void addSJMethod(SJMethodInstance sjmi)
	{
		sjMethods.add(sjmi);
	}

	public void addSJThread(SJThreadInstance sjti)
	{
		sjThreads.add(sjti);
	}

	public SJMethodInstance findSJMethod(String name, List<SJType> argTypes) throws SemanticException
	{
		for (SJMethodInstance sjmi : sjMethods)
		{
			if (sjmi.name().equals(name) && SJCompilerUtils.getSJFormalTypes(sjmi).equals(argTypes))
			{
				return sjmi;
			}
		}

		throw new SemanticException("Session-method not found: " + name + ", " + argTypes);
	}

	public SJThreadInstance findSJThread(String name) throws SemanticException
	{
		for (SJThreadInstance sjti : sjThreads)
		{
			if (sjti.name().equals(name))
			{
				return sjti;
			}
		}

		throw new SemanticException("Session-thread not found: " + name);
	}

	public void addSocket(SJNamedInstance sjni) // Throw SemanticException? And/or handle within SJContext?
	{
		throw new RuntimeException("Field session sockets not allowed: " + sjni);
	}

	public void addServer(SJNamedInstance sjni)
	{
		throw new RuntimeException("Field servers not allowed: " + sjni);
	}

	public boolean hasSocket(String name)
	{
		throw new RuntimeException("Field session sockets not allowed: " + name);
	}

	public boolean hasServer(String name)
	{
		throw new RuntimeException("Field servers not allowed: " + name);
	}

	public SJNamedInstance getSocket(String name)
	{
		throw new RuntimeException("Field session sockets not allowed: " + name);
	}

	public SJNamedInstance getServer(String name)
	{
		throw new RuntimeException("Field servers not allowed: " + name);
	}
}
