/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.visit.contexts.sesscontexts;

import polyglot.types.SemanticException;

import sj.types.typeobjects.sesstypes.SJType;

public class SJInbranchContext_c extends SJBranchContext_c implements SJInbranchContext
{
	private String session; // Duplication from session operation context - instead inheriting code from branch context.

	public SJInbranchContext_c(String session, SJType sjType, SJSessionContext sjsc) throws SemanticException
	{
		super(sjsc);

		this.session = session;

		openSession(session, sjType);
	}

	public String session()
	{
		return session;
	}

	public void addBranchCase(SJIOBranchCaseContext sjbcc)
	{
		super.addBranchCase(sjbcc);
	}
}
