/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.visit.contexts.sesscontexts;

import polyglot.types.SemanticException;

import sj.types.typeobjects.sesstypes.SJType;
import sj.util.SJLabel;

public class SJRecursionContext_c extends SJSessionOperationContext_c implements SJRecursionContext // Don't need to inherit any code from SJWhileContext_c - just to signify a loop-context (for delegation checking).
{
	private SJLabel lab;

	public SJRecursionContext_c(String session, SJLabel lab, SJType sjType, SJSessionContext sjsc) throws SemanticException
	{
		super(session, sjType, sjsc);

		this.lab = lab;
	}

	public SJLabel label()
	{
		return lab;
	}
}
