/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.visit.contexts.sesscontexts;

import java.util.*;

import sj.types.typeobjects.sesstypes.*;
import sj.util.*;

public class SJRecursiveMethodContext_c extends SJMethodContext_c implements SJRecursiveMethodContext
{
	public SJRecursiveMethodContext_c(String name, SJMap sjFormals, SJType returnType)
	{
		super(name, new HashSet<String>(), sjFormals, returnType);

		for (String session : sjFormals.keySet())
		{
			SJType sjType = (SJType) sjFormals.get(session);

			if (sjType instanceof SJRecursionType) // Label and method name match checked by SJTypeBuilder (works in conjunction with type well-formedness).
			{
				sjType = ((SJRecursionType) sjType).body(); // Relaxed to support non-recursion type arguments.
			}

			openSession(session, sjType);

			SJCompilerUtils.debugPrintln("Opened: `" + session + "' " + sjType);
		}
	}
}
