/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.visit.contexts.sesscontexts;

import java.util.Set;

import sj.types.typeobjects.sesstypes.SJType;
import sj.visit.contexts.*;

// Move session contexts to a subpackage?
public interface SJSessionContext extends SJCodeContext
{
	public Set<String> activeSessions();
	public Set<String> implementedSessions();
	public Set<String> sessionsInScope();

	public boolean sessionOpen(String sessionName);
	public boolean sessionInScope(String sessionName);

	public SJType originalType(String sessionName);
	public SJType activeType(String sessionName);
	public SJType implementedType(String sessionName);

	public void openSession(String sessionName, SJType sjType);
	//public void originalType(String sessionName, SJType sjType);
	public void activeType(String sessionName, SJType sjType);
	public void implementedType(String sessionName, SJType sjType);

	public void removeSession(String sessionName);
}
