/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.runtime.net;

import java.io.Serializable;

public class SJDelegationSignal implements Serializable
{
	public static final long serialVersionUID = 1L;

	private String hostAddress;
	private int port;
	private String targetState;

	public SJDelegationSignal(String hostAddress, int port)
	{
		this.hostAddress = hostAddress;
		this.port = port;
	}

	public SJDelegationSignal(String hostAddress, int port, String targetState)
	{
		this.hostAddress = hostAddress;
		this.port = port;
		this.targetState = targetState;
	}

	public String hostAddress()
	{
		return hostAddress;
	}

	public int port()
	{
		return port;
	}

	public String targetState()
	{
		return targetState;
	}

	public String toString()
	{
		return "SJDelegationSignal";
	}
}
