/*
 * This file is part of SessionJ.
 *
 * Copyright (C) Raymond Hu, Imperial College London.
 *
 */

package sj.runtime.net.contexts;

import sj.types.typeobjects.sesstypes.SJType;

public abstract class SJSocketContext // Need to be generalised to support multiple sessions, for sessrec methods, and later generalisation of all session operations.
{
	private static final int CONTEXT_CLASS_PREFIX = "class sj.runtime.net.contexts.".length();
	private static final int CONTEXT_CLASS_SUFFIX = "Context".length();

	private SJType active;
	//private SJType current; // Currently performing.
	private SJType implemented; // Performed.

	public SJSocketContext(SJType active)
	{
		this.active = (active == null) ? null : active.treeClone();
	}

	public SJType activeType() // No cloning ok?
	{
		return active;
	}

	public final SJSocketContext activeType(SJType active)
	{
		this.active = active;

		return this;
	}

	/*public SJType currentType()
	{
		return current;
	}

	public SJSocketContext currentType(SJType current)
	{
		this.current = current;

		return this;
	}*/

	public final SJType implementedType()
	{
		return implemented;
	}

	public final SJSocketContext implementedType(SJType implemented)
	{
		this.implemented = implemented;

		return this;
	}

	public String toString()
	{
		String m = this.getClass().toString();

		return m.substring(CONTEXT_CLASS_PREFIX, m.length() - CONTEXT_CLASS_SUFFIX);
	}

	/*public boolean isTopLevelContext()
	{
		return false;
	}

	public boolean isBranchContext()
	{
		return false;
	}

	public boolean isOutbranchContext()
	{
		return false;
	}

	public boolean isInbranchContext()
	{
		return false;
	}

	public boolean isIterationContext()
	{
		return false;
	}

	public boolean isOutwhileContext()
	{
		return false;
	}

	public boolean isInwhileContext()
	{
		return false;
	}

	public boolean isRecursionContext()
	{
		return false;
	}*/
}
