package benchmarks.macro.socket;

import java.io.*;
import java.net.*;

public class BenchmarkClient {
    
    public BenchmarkClient(String server, int port, int id) throws Exception {
        super();
        InetSocketAddress addr = new InetSocketAddress(server, port);
        Socket s = null;
        ObjectOutputStream oos = null;
        ObjectInputStream ois = null;
        long timeStarted = -1;
        long timeFinished = -1;
        try {
            s = new Socket(addr.getAddress(), addr.getPort());
            s.setTcpNoDelay(true);
            oos = new ObjectOutputStream(s.getOutputStream());
            ois = new ObjectInputStream(s.getInputStream());
            timeStarted = System.currentTimeMillis();
            oos.writeBoolean(true);
            oos.flush();
            Integer v = (Integer) ois.readObject();
            oos.writeBoolean(false);
            oos.flush();
            timeFinished = System.currentTimeMillis();
            System.out.println("Response time: " +
                               (timeFinished - timeStarted));
        }
        catch (Exception x) {  }
        finally {
            System.out.println("Finished: " + id);
            close(ois, oos, s);
        }
    }
    
    public static void main(String[] args) throws Exception {
        new BenchmarkClient(args[0], Integer.parseInt(args[1]),
                            Integer.parseInt(args[2]));
    }
    
    private void close(ObjectInputStream ois, ObjectOutputStream oos,
                       Socket s) {
        try {
            if (oos != null) {
                oos.flush();
                oos.close();
            }
            if (ois != null) ois.close();
            if (s != null) s.close();
        }
        catch (IOException ioe) {  }
    }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1208970616095L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAI1WW2xURRievXTbbVd74V6gLaUEkLD1SpA+YG1AFpZ0bfFC" +
       "LVlmz862p51zYWbO\ndkElGhNBHkwIeEu8vJiQGJ4g6oMmmoB3H0wfxBdMDM" +
       "aYKEQejMRg9J855+zl7FJsMqezM99/mf/y\nzZy9ipo4Q322RQ9PUUskxWGb" +
       "8GQGM07yIxRzvg8Wstq2tTfnvj22e2UEtU+gdt0cF1jo2ohlClIS\nEyhhEC" +
       "NHGB/O50l+AnWahOTHCdMx1Y8A0DInUBfXp0wsHEb4GOEWLUpgF3dswpRNfz" +
       "GNEpplcsEc\nTViMC9SRnsFFPOgInQ6mdS6G0ihW0AnN80PoKAqlUVOB4ikA" +
       "Lk37pxhUGgd3ynWAt+rgJitgjfgi\n0VndzAvUG5Qon3hgDwBAtNkgYtoqm4" +
       "qaGBZQl+sSxebU4LhgujkF0CbLASsCdd9SKYBabKzN4imS\nFWh5EJdxtwAV" +
       "V2GRIgItCcKUphJD3YGcVWVrNJb450Tmr76w8jlPNCr9bwKhnoDQGCkQRkyN" +
       "uII3\nnOTp1H5nVRghAC8JgF3M8LoPH0v/+kmvi1nZADOamyGayGo3t6xaPT" +
       "/8czwi3WixLa7LUqg5ucpq\nxtsZKtlQi0vLGuVm0t/8dOzz/c+9R34Lo5YU" +
       "imkWdQwzheLEzI9482aYp3WTuKujhQInIoWiVC3F\nLPUbwlHQKZHhiMLcxm" +
       "JazUs2QqgZRgjGXuT+xeUHsv0wBGjawGx2hOrEFEk+I9D9gnDBJznTJnP+\n" +
       "Np80sMasSW5ps0RM1ouVpK075kIhOOaqYMtRqM9dFs0TltXOXPn6mR17Xjoe" +
       "Lhed56VA6yvmkspc\n0jWXDJhDoZCys6w2nDI/edlGv58b6nh5M/8gjCITKK" +
       "4bhiNwjhJoP0ypNUfyWaHqr7Oq1lWJQX0m\nclCqUPVZCopUa0D8igz1B0uy" +
       "0sgpmGGos/mj/353LTt3XlaPzPZiqd11DXI36/qW2Dh+YPfB4/0R\nCZqLyr" +
       "QAdOD22rPatRN7z3//zeUNldIXaKCuI+slZUcF3c8wSyN5YKyK+tf+3vXHqa" +
       "YH3w/L8okD\nUQkM5QVd3xO0UdNZQz5LyWCF06itYDEDU7nlU0urmGbWXGVF" +
       "1Uqbmt8JAWiBATFDW73abJMfudkh\nP51uZcl4Bs6gOPDGC7G7L33c9lm4mi" +
       "7bq3h1nAi3+Tor6djHCIH1y69nTr1y9dhTKhdeMgSK2U6O\n6lpJ+bckBLlf" +
       "1IAIkssXn35145uX/GQvqmgfZgwflrkuPT+/+o0v8FtAEtCsXD9CVC9GlKWI" +
       "0t8F\nl4CSlEWYdAmX13NZhukGUEXR47KTPe/+cv7K2OJwFeGvrePcahmX9F" +
       "UoW+0SWFizkAWFvrhpzdmj\nYz/mXDLsqu21HaZjPPDOD2TjQwmtQSdH4FqS" +
       "P+7xoyi/d6n5Jhllr/C9CCyqRGBHSSO25ETlap8n\nLhswSCo75T3pV6+Re/" +
       "rPC2+39rnZkDLdygRSagY8LRUn/F0IxOpb3TUqCMeevJ54EV88EPZU3SdQ\n" +
       "XFj2ZkqKhFacCyrZq65W37v2J3p/2rnlzLNB78JgvndByazWWVz5aGRa/xK4" +
       "rNz0dXd7rdBQdTag\n+xiBp4kpjyRXmtU5esrd1w5jPYxtXvdta9h98tuvvu" +
       "vcRgnL+XroFq6eSwvnuf5GVz3iFvO5yMD1\n8EdLBxTvRHOYu24Gn0L1L52a" +
       "B4zyM14+1QoYvbc51Wbbthf0W/7cqqApgaIG0KFCDHpS98Ji0dJd\nBx4pm5" +
       "ZXaxrGds/09v8XUGCeZpvpRQzPzoZOBWhjhWoa3Uq6T5KUaTsC+INgw0d01y" +
       "JGHVEHaVcQ\nE67YcXXTNraMqnppv0BNGrXcJD1eAhWBy1mS4fK6N7f7MtT6" +
       "5w9uuGB3fuXm2n+9xeAJVXAorSra\n6gKO2YwUdGU95l4dtvo3K9CyW7wYZF" +
       "2qiTrDjIuHh0NHEA+nUf+rcYcEaq3g5AqzG5C1G9XSfxcq\ntJBnDAAA");
}
