package benchmarks.macro.socket;

import java.io.*;
import java.net.*;

public class SocketServer {
    private ServerSocket ss = null;
    
    public SocketServer(int port) throws Exception {
        super();
        ss = new ServerSocket(port);
        int id = 0;
        Socket s = null;
        while (true) {
            try {
                s = ss.accept();
                s.setTcpNoDelay(true);
                this.new ServerThread(id, s).start();
                System.out.println("Accepted: " + id++);
            }
            catch (Exception x) { x.printStackTrace(); }
        }
    }
    
    private class ServerThread extends Thread {
        final private Socket s;
        final private ObjectInputStream ois;
        final private ObjectOutputStream oos;
        final private int id;
        
        public ServerThread(int id, Socket s) throws IOException {
            super();
            this.id = id;
            this.s = s;
            this.ois = new ObjectInputStream(s.getInputStream());
            this.oos = new ObjectOutputStream(s.getOutputStream());
        }
        
        public void run() {
            try {
                oos.writeObject(new Integer(id));
                oos.flush();
                int v = 0;
                for (boolean redo = ois.readBoolean(); redo;
                     redo = ois.readBoolean()) {
                    oos.writeObject(new Integer(v++));
                    oos.flush();
                }
            }
            catch (Exception x) { x.printStackTrace(); }
            finally {
                close(oos, ois, s);
            }
        }
        
        private void close(ObjectOutputStream oos, ObjectInputStream ois,
                           Socket s) {
            try {
                if (oos != null) oos.close();
                if (ois != null) ois.close();
                if (s != null) s.close();
            }
            catch (IOException ioe) {  }
        }
        
        final public static String jlc$CompilerVersion$jl = "2.2.3";
        final public static long jlc$SourceLastModified$jl = 1209049251807L;
        final public static String jlc$ClassType$jl =
          ("H4sIAAAAAAAAAI1Xa2xURRSe3W23tCz2wbuUtpSiQGELiaLYxFgbKguLXdsC" +
           "UkuW2Xtnt5fevfc6\nd+52QWkkPnj8MDHgK1H4Y0Ji+GEk6h+jJuBbE9Mf4B" +
           "9IDMaYKER/GInB6JmZe/dxd0vdZGZnZ86Z\nc+ac7zsze/4GqrUp6rRM/VBG" +
           "N1mUHbKIHU1gahN1QMe2PQoTSeXB1benvj22Y0UINY6hRs0YYZhp\nyoBpMJ" +
           "JnYyiSJdkUoXa/qhJ1DDUbhKgjhGpY1w6DoGmMoRZbyxiYOZTYw8Q29RwXbL" +
           "Edi1Bh05uM\no4hiGjajjsJMajPUFD+Ic7jXYZreG9ds1hdH4bRGdNV+Ck2j" +
           "QBzVpnWcAcElce8UvWLH3kE+D+IN\nGrhJ01ghnkrNpGaoDHX4NQon7t4JAq" +
           "BalyVswiyYqjEwTKAW6ZKOjUzvCKOakQHRWtMBKwy1zrop\nCM2zsDKJMyTJ" +
           "0DK/XEIugVS9CAtXYWixX0zslKeo1ZezkmwNhSP/nEz81RkUPqtE0bn/taDU" +
           "7lMa\nJmlCiaEQqXjLiZ6O7XPaggiB8GKfsJTpX/Ph7vgvn3RImRVVZIZSB4" +
           "nCksrtLW0rZ/p/qg9xN+ZZ\npq1xKJSdXGQ14a705S3A4pLCjnwx6i1+Ovz5" +
           "vmffIb8G0bwYCium7mSNGKonhjrgjutgHNcMImeH\n0mmbsBiq0cVU2BS/IR" +
           "xpTSc8HDUwtjCbEOO8hRCqhwanQvuQ/KzlHUONI6YySRjgOUdo1D7I0GZG\n" +
           "bGaP21QZT0HwJrKYTtrjWaxQc9wWwuM+nTy3smAqEIADtvnJpgMyt5u6SmhS" +
           "OXf962e27TxxPFiA\nm+sfWC3aigpbUWkrWmqrW36NTlCCVRQICItLy0PKc6" +
           "RyKv32Xl/TSxvtD4IoNIbqtWzWYTilE6Ag\n1nVziqhJJjDYXIJ3ATPAaCQF" +
           "cAXkJ3XYSNADYpijqMsPyyKZYzDCgLWZ6X+/v5mcusARxDO+iO8u\nXYP8TU" +
           "rfIutG9u84cLwrxIWmaiAT/CTdc++eVG6e3HXh8jdX1xbhz1B3BSsrNTmr/O" +
           "4nqKkQFapW\ncfvX/t7++6nare8HOYTqoVgxDBAD5rf7bZSxq8+rVDxYwTia" +
           "nzZpFut8ySsvDWyCmlPFGYGa+WJ8\nl4tPCAe638XnJt7xxSbeNUuM8Xj6zi" +
           "Dq4K3nwpuufDT/s2BpyWwsqa0jhEkCNhfTMUoJgfmrrydO\nvXLj2JMiF24y" +
           "GApbTkrXlLzwb3EAcr+wSjGILlt0+tV1b17xkr2wuHs/pfgQz3X+6MzKN77A" +
           "b0Gh\nAMLa2mEi+BgUloJ2ZdlKUC0LVSHnlq2X29/++cL14UXBktq+uqK8lu" +
           "rI+i4i1mDlwcKqO1kQ0pd6\nVp2fHr6WknWvpZxS2wwne9/ZH8i6hyNKFeqG" +
           "4AYSYWqBmIsAGAXeevHj/Xox7uHxdSHvKsmoaWY0\nNrQtrxCLV0Thfaerzq" +
           "nnLyyD/Jb0cJtNPf3nxTMNnTIPXKdVmKipEt4yxaRy+OPdZ259x66JgxUB\n" +
           "z/foyFea3YNLuPjA5Vxz+N2z2SCqG0NN4mbHBtuDdYcDawzuZnvAnYyjBWXr" +
           "5fesvFT6CoRu8+e3\nxKyfasVkwJhL83Gdj11N0JZDW++ya72PXQFk8cEjQq" +
           "FL9GskF4IMzGkGBq/qLKrlMH8Uubm7V5KS\n9w+VmbobWo9rqqe6qVgVU3w8" +
           "yLtHwUTI1GwPIcs9hMhAxQzLYfA2ITg7mwf3QNvgerChugeJuT0w\nCx60ln" +
           "sw5LA5XVgKLeq6EK3uwt65XAhqKh/2Chv5SumAFHRpUmSZhD/i5F8521NKEP" +
           "/YE39EXsSX\n9nPmcMXNUPrc926Bev4ddolno4fHxr0dPw5uOXfEzz1e2jru" +
           "qJlUmnMrHg9NaF/CHV3AfsW7tVyp\nrxzxDZTAs9sYLcN9e9mtshDaVjcPW6" +
           "vdKrzrrlqokBfGOy3y3xqghTqGWNtoSflNDNXkTE2+rzMF\nlxqg7YI25Lo0" +
           "NJtL41WthoTVEP+5m3ePCSLO7SFciLWKbtoiTBZAK1L6mPJg3v1/nmGQ2GUV" +
           "/6nk\ny1/pmjmw9qLV/JV4PxRe52F4IqcdXS8tVSXjsEVJWhNuhmXhssTXNE" +
           "NLZ3EIYCoHwvMjUv4o/KHy\ny8OxxXep3PMMNRTl+MwLlheBJkF0XpWjMjT5" +
           "/wDnsJueRw4AAA==");
    }
    
    
    public static void main(String[] args) throws Exception {
        new SocketServer(Integer.parseInt(args[0]));
    }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1209049251807L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAIVWXWxURRSe/em22y62WygglLaUIiBhCw8StS80DYTKEtYu" +
       "oCwly+y9s9tL758z\nc7cLKtGYCPJgYsC/ROHFhMTwYCDqg0ZNwH9NTB/AF0" +
       "gMxpgoRB6MxGD0zNy9u3fvtrXJ3M7OnDPn\nzDnfd+ZcuIVaGEUDtqUfLekW" +
       "T/GjNmGpDKaMqGM6ZmwvLOSVR9fcm/nuxGMrI6gzhzo1M8sx15Qx\ny+Skwn" +
       "MoYRCjQCgbVVWi5lDSJETNEqphXTsGgpaZQ91MK5mYO5SwCcIsvSwEu5ljEy" +
       "pteotplFAs\nk3HqKNyijKOu9BFcxsMO1/ThtMb4SBrFihrRVfYUOo5CadRS" +
       "1HEJBJemvVsMyxOHd4h1EG/XwE1a\nxArxVKLTmqly1B/UqN14aBcIgGqrQf" +
       "iUVTMVNTEsoG7XJR2bpeEsp5pZAtEWywErHK2Y91AQarOx\nMo1LJM/R8qBc" +
       "xt0CqbgMi1DhqCcoJk+qULQikDNftvbEEv+cyvw1EJY+q0TRhf8toNQXUJog" +
       "RUKJ\nqRBX8a6TOjN+wOkNIwTCPQFhV2Z07Yf70r9+2u/KrJxDZk/hCFF4Xr" +
       "m3tXfV7OjP8Yhwo822mCag\n0HBzmdVMdWekYgMWl9ZOFJspb/OziS8OPPcu" +
       "+S2M2sZRTLF0xzDHUZyY6lh13grztGYSd3VPscgI\nH0dRXS7FLPkbwlHUdC" +
       "LCEYW5jfmUnFdshFArjBCMPHL/4uLDUWfWUqYJBzyXCU2xIxxt4YRxNsmo\n" +
       "MlmA4E0ZmE6zSQMr1JpkUngyoFMRVhbNhEJwwd4g2XRA5k5LVwnNK+dvfvPM" +
       "9l0vnQzX4Fb1j6Oh\nuq2UtJVybaX8tlAoJI0sa4yiSIsq2PP7xZGulzexD8" +
       "IokkNxzTAcjgs6AdZhXbdmiJrnEnZJH8Ql\nsgCWiQIgFMCe1+EgyQgIW5mi" +
       "wSAS6/wdhxkGeM0e//eH2/mZSwI0IslLxOmua5Cyade3xIbsoccO\nnxyMCK" +
       "GZqMgGiA79/+l55fap3Zeufnt9fR3xEK8mIjZrCiIF3c9QSyEqFKr68a//vf" +
       "OP0y2PvB8W\nqIlDfeIYUAVk7wvaaCDUiFecRLDCadRRtKiBdbHlVZR2PkWt" +
       "mfqKBEqHnN8HAWiDATFDD1QhuUh8\nxGaX+CRdWIl4Bu4gS9/dF2Kbr33c8X" +
       "nYXyU7feU0S7jLuWQ9HXspIbB+/Y3M6VdvnTgoc1FNBkcx\n2ynomlKR/vWE" +
       "IPeL5+B/avmSM69teOual+zF9dNHKcVHRa4rz8+uevNL/DbUBuAo044RScFQ" +
       "Le3B\nSpWhmgGFoFytVK/0vfPLpZsTS8K+cr6mqaL6ddySLiPWblfAwuqFLE" +
       "jpKxtXXzg+caPglrruRkpt\nNx3joXM/kg3bEsocbI3Ao+PFSXwflPONvjuK" +
       "3928Gh1BtNT2ikJsUeyklwNVdUGxYM3YIR5AD59G\n4ek/L59tH3DjLXRWzB" +
       "vGBsW8cuyTfWfvfs9vyAvUgS3O6K80m92PfZx7+Go5GXvvnBFGrTnUJR9t\n" +
       "bPL9WHcEgHLw7LKx6mIaLWrYb3xC3fdipEbc3mAefWaDlKoHHeZCWsxbAywS" +
       "hXwARkeVRR0BFoWQ\nLSbbpMKg/K6tYb7VploZiz4HhRnzstYjs2aK6ivrrl" +
       "uDJR2l8aFq7uqpd3OCBPJWzfd0S9SdePJO\n4kV85ZBIp1DcwlGcW/YmnZSJ" +
       "XodE8JDdslPx4tT5RP9PO7aef3YuTPQvqJlXkuWVj0emtK/gjajl\npKlVal" +
       "QaacxEOyXQ6Zl7G/LRV8tHJ4x1MA5W83FwzqrWlIywmK+DKsRk97kwu5obJF" +
       "l73OpxMTJ0\nJ/zR0iFZz6MFzFw3g51lc+PY0A9KP+O1W90Po3+BW3nQ6aoT" +
       "3m0ebdte8C7i51ZpLMtR1ACGSolN\nVa3NsFi2NBUAmvC3AqL0Lm9q7N32Ux" +
       "mcPbz+sp382o2A1yLGoE8rOrruJ5VvHrMpKWrSk5hLMVv+\nK3G0bJ7mRGRL" +
       "TqSrRVceWqiuoDxHLfK/X87gqL0uJ1ZMe44ouvWj8h+oZI21zAwAAA==");
}
