package benchmarks.micro.rmi;

import java.io.*;
import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.server.*;
import benchmarks.micro.BigObject;

public class RMIServerImpl extends UnicastRemoteObject implements RMIServer {
    private int bigObjectSize;
    private int run = 0;
    private int id = 0;
    private boolean foo = true;
    
    public RMIServerImpl() throws RemoteException { super(); }
    
    public BigObject getBigObject100(boolean b) throws RemoteException {
        if (b) { return new BigObject(id++, 100 - 86); } else { return null; }
    }
    
    public BigObject getBigObject10000(boolean b) throws RemoteException {
        if (b) { return new BigObject(id++, 10000 - 86); } else { return null; }
    }
    
    public static void main(String[] args) throws IOException {
        RMIServer remoteObject = new RMIServerImpl();
        System.setSecurityManager(new RMISecurityManager());
        Registry registry = LocateRegistry.getRegistry();
        registry.rebind(args[0], remoteObject);
    }
    
    public BigObject getDummy(boolean b) throws RemoteException {
        if (b) { return new BigObject(-1, 100 - 86); } else { return null; }
    }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1209050477438L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAALVXXWxURRSe3W633dLaH1rAtrSlLQFEtvUBAvZBS6XpwpLW" +
       "lqLUkmX27uz20vvn\n3LnbLSrRkAiikSj4lyi8mJAYHgxEfdCoCfiviekD+A" +
       "KJwRgThciDkRiMnpl77+7eu0v1hU3m7ty5\n52/O+c45M2euoUqToi5DV+Yz" +
       "is6ibN4gZnQMU5OkhhRsmrtgISHd33Nr7tvD29sqUP0Uqpe1CYaZ\nLA3pGi" +
       "M5NoVqVaImCTUHUymSmkKNGiGpCUJlrMgHgFDXplCTKWc0zCxKzHFi6kqWEz" +
       "aZlkGo0Oku\nxlGtpGsmo5bEdGoy1BDfj7O4z2Ky0heXTTYQR+G0TJSU+Tg6" +
       "iAJxVJlWcAYIl8XdXfQJiX3DfB3I\na2Qwk6axRFyW0KyspRjq9HPkd9y7Aw" +
       "iAtUolbEbPqwppGBZQk22SgrVM3wSjspYB0krdAi0Mtd5W\nKBBVG1iaxRmS" +
       "YGiFn27M/gRUEeEWzsJQi59MSMpR1OqLWVG0RsO1fx8d+7MrKGxOEUnh9lcC" +
       "U4eP\naZykCSWaRGzGm1b0RGyP1R5ECIhbfMQ2zeDqDybjv3zSadO0laEZTe" +
       "4nEktItza1r1wY/ClSwc2o\nNnRT5lDw7FxEdcz5MpAzAIvL8hL5x6j78dPx" +
       "z/c8/Q75NYiqYygs6YqlajEUIVpqyJlXwTwua8Re\nHU2nTcJiKKSIpbAu3s" +
       "EdaVkh3B0hmBuYzYh5zkAIVcEIwNiH7F8DfwAAx3fGAMxZQmOqoUTN/Qz1\n" +
       "MWIyc9qk0nQSvDejYjprTquyRPVpqsrTfo4cV1I3FwjA/tr9uaYAMEd0JUVo" +
       "Qjp99esnt+147kgw\njzbHPIa6C5qiQlMUNEU9mlAgIFQs97qQxyTFU+e3sw" +
       "MNL24w3w+iiikUkVXVYjipEEg5rCj6HEkl\nmMBcYxG+BawAk7VJgCcgPaGA" +
       "IJEO4LMsRd1+GBaSNwYzDNhaOPjP99cTc+c4YniEm7l02zSI16xt\nW+26ib" +
       "3b9x3pruBEcyEeCiDt/W/pCen60Z3nLn5zeW0B7gz1lmRhKSfPIr/5Y1SXSA" +
       "qqVEH8a3+N\n/H68cst7QQ6ZCBQnhgFSkOkdfh2ebBpwKxN3VjCOlqR1qmKF" +
       "f3LLSQ2bofpcYUXAZImY3wUOqIYB\nPkPtDh7v5g/+sYE/Gm1QcX/69iDq3s" +
       "1D4f5LHy35LFhcIuuLaukEYXbCNRbCsYsSAuuXXx87/sq1\nw4+JWDjBYChs" +
       "WElFlnLCvpYAxH5pmeSPrmg+8eq6Ny+5wV5akD5IKZ7nsc49s7DyjS/wW1AY" +
       "IEFN\n+QAR+YeEJuQq4M97xHw9N8DBBH9vghoixIoMIKrOyLacRAxeJ4RXuh" +
       "wZHKD+fBvmvcONrpp84o/z\nJ2u6bGs5T6vQEzJLa6WHMSEd+Hjy5M3v2BXh" +
       "4AIsuIzOXKna3bgIsZsvZhvD755Sg6hqCjWIfoc1\nthsrFnf/FHQsc8hZjK" +
       "M6z3dv97FL7UAe9u1+SBap9QOyUF5gzqn5vMqHwQiMNhhNDgabfBgMIINP\n" +
       "tgiGbvFcnUdMlUHlLOZHBFSXlDO2sRMQ7jLeHaOyCoU+63Silzre/vnc1fHm" +
       "YFG77inpmMU8dssW\n5tcYOdCwajENgvrC+lVnDo5fSdqtrMlbNbdplrrx1A" +
       "9k3YO1UplyXAGHCjsB+XOjx2EtMJodhzWX\nd9gwfwyAGGppfDp4O1nNjjzk" +
       "/pfKijmygnJqUVG8jix3RC0vLyrumpXWdcH7gGGn0laIZlLXFYKF\nuXXCz7" +
       "1OlhUytdWbpR2L9ywepZW3O8aICB1+9Ebts/jCXh4hLnOIoQjTjQ0KyRKlkO" +
       "N+ITvFqc0F\nfv0jnT8Obzr9VLkk71yUMyE1ZtserpiRv4SWmU+ykmOjl2nA" +
       "m1o1lMCpV9vlSbAOT5G/F0aPE5ie\nckW+yNnlyyJ/HV20cPLXPiENzp71Gc" +
       "K2ugl5X3+/G6/WknjlqQTJXo/ZURibHbM333GzZ+Bc4jO7\nv59/SPtMq4ex" +
       "BsaIY9pI2bZZUq+CfL4G2pwp7jaLd6HS47dobnbtOlvReyP44bJecWAIJbFp" +
       "B95/\nbym9lnhuG8LOSH5XvPl3LrIrN4QNojHy5hC1ryaGYfyvjmo3almPxk" +
       "a9zVRnKKRCb/PXg1BWl1Nl\nYLEaxqRj5eQdh8UhhqoBFg9Zqjov0MCbjedU" +
       "zE8hK0ouuPY1TOpe2Lf2vNH4lR0r96oUhvtK2lKU\n4g5ZNA8blKRloT5s90" +
       "tD/L3AUHO5isfLvCqLPTxvUx6DQPkpGaoU/8V0LzNUU6DjK8cNN2A9+SOQ\n" +
       "KfYandRkCZvMPhDZSZL7Fyuqpm3hDwAA");
}
