package benchmarks.micro.socket;

import java.io.*;
import java.net.*;
import benchmarks.micro.BigObject;

public class SocketClient {
    
    public SocketClient(String server, int port, int msgSize, int sessLen)
          throws Exception {
        super();
        InetSocketAddress addr = new InetSocketAddress(server, port);
        dummyrun(addr);
        Socket s = null;
        ObjectOutputStream oos = null;
        ObjectInputStream ois = null;
        long timeStarted = -1;
        long timeFinished = -1;
        try {
            timeStarted = System.nanoTime();
            s = new Socket(addr.getAddress(), addr.getPort());
            s.setTcpNoDelay(true);
            oos = new ObjectOutputStream(s.getOutputStream());
            ois = new ObjectInputStream(s.getInputStream());
            for (int k = 0; k < sessLen; k++) {
                oos.writeBoolean(true);
                oos.flush();
                BigObject bo = (BigObject) ois.readObject();
            }
            oos.writeBoolean(false);
            oos.flush();
            timeFinished = System.nanoTime();
        }
        finally {
            close(ois, oos, s);
        }
        System.out.println(Math.round((float) (timeFinished - timeStarted) /
                                        1000.0));
    }
    
    public static void main(String[] args) throws Exception {
        new SocketClient(args[0], Integer.parseInt(args[1]),
                         Integer.parseInt(args[2]), Integer.parseInt(args[3]));
    }
    
    void dummyrun(InetSocketAddress addr) throws Exception {
        Socket s = null;
        ObjectOutputStream oos = null;
        ObjectInputStream ois = null;
        try {
            s = new Socket(addr.getAddress(), addr.getPort());
            s.setTcpNoDelay(true);
            oos = new ObjectOutputStream(s.getOutputStream());
            ois = new ObjectInputStream(s.getInputStream());
            for (int k = 0; k < 1; k++) {
                oos.writeBoolean(true);
                oos.flush();
                BigObject bo = (BigObject) ois.readObject();
            }
            oos.writeBoolean(false);
            oos.flush();
        }
        finally {
            close(ois, oos, s);
        }
    }
    
    private void close(ObjectInputStream ois, ObjectOutputStream oos,
                       Socket s) {
        try {
            if (oos != null) {
                oos.flush();
                oos.close();
            }
            if (ois != null) ois.close();
            if (s != null) s.close();
        }
        catch (IOException ioe) {  }
    }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1210947032195L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAI1XW2xURRievXTbbReXlnIr0JZSBCRsvUS89MWm4bKw0LVF" +
       "lLpkOXvObHvac3Nm\nznaLQDQmgjyYGPCWeHkxITE80agPmmgC3n0wfRBfMD" +
       "EYY6IQeTASg9F/Zs7ezi6lTWZ2zsx////v\nn+n5a6iJEtTr2MbshGGzBJt1" +
       "ME2kFUKxNmwolB6Ajaz66IZbM9+d3LMmhOLjKK5bY0xhujpsWwwX\n2TiKmd" +
       "jMYUKHNA1r46jdwlgbw0RXDP0oENrWOOqg+oSlMJdgOoqpbRQ4YQd1HUyEzt" +
       "JmCsVU26KM\nuCqzCWVoaWpKKSgDLtONgZRO2WAKRfI6NjT6DDqBAinUlDeU" +
       "CSBckSp5MSAkDuzk+0DeqoOZJK+o\nuMQSntYtjaEeP0fZ4/69QACszSZmk3" +
       "ZZVdhSYAN1SJMMxZoYGGNEtyaAtMl2QQtDXbcVCkQtjqJO\nKxM4y9AqP11a" +
       "HgFVVISFszC03E8mJBUJ6vLlrCpbI5HYv6fTf/cGhc0aVg1ufxMwdfuYRnEe" +
       "E2yp\nWDLedBNnk4fctUGEgHi5j1jSDG386InUb5/2SJo1DWhGclNYZVn11v" +
       "a16+aHfomGuBktjk11Xgo1\nnouspr2TwaIDtbiiLJEfJkqHn41+cei59/Hv" +
       "QdSSRBHVNlzTSqIotrRhb90M65RuYbk7ks9TzJIo\nbIitiC2+IRx53cA8HG" +
       "FYOwqbFOuigxBqhhGAcQzJvzY+MRQfs9VpzIYNHVssQacYeiiRyNCpDMOU\n" +
       "0QwlaiYHIZw0FTJNM6auEjtDBUvGx1nkupbMBALg5lo/5Ayoz922oWGSVc9d" +
       "/ebYjr0vnQqWi86z\nkqH+iq6E0JWQuhLVulAgIJSsrI0lT47GMfTHhcGlL2" +
       "+jHwZRaBxFddN0mZIzMGBPMQx7BmtZJoqv\nvarQRX1BccZyUKdQ8lkDBAlc" +
       "QPAKBPX567GC4iSsFCiy+RP/fX89OzPHS4enupNLl6ZB4qalbbEt\nY4f3HD" +
       "nVF+JEM2GeEyDtv7P0rHr99L65H769srlS9xCvOjjWc3I4+c1PE1vFGrSriv" +
       "jX/9n955mm\nRz4I8tqJQpdiCtQWQL7br6MGVoOlFsWDFUyhtrxNTMXgR6W+" +
       "0somiT1T2RGF0ibWd0EAWmBAzNAu\nrzCX8IkfLuVTuywrHk+fD6IB3nwhcu" +
       "/lT9o+D1b3ynhVUx3DTCKvvZKOAwRj2L/yRvrMq9dOPi1y\n4SWDoYjj5gxd" +
       "LQr7lgcg98sadIHEqs6zr21563Ip2csq0ocIUWZ5rovPz69780vlbegQgFSq" +
       "H8UC\niGGhKSzkd8ANIDh5ESZkt6X1jSxNdBP6RMFrZK90v/fr3NXRzmBVt9" +
       "9Q13CreWTHF6FsdYqgYf1C\nGgT1pa3rz58Y/SknO2FHLdZ2WK754Ls/4i2P" +
       "xdQGMA7BncQ/7hNTKZR8vkest/JQe9XvhWFZJQw7\niip2eFcU9vZ67ByF/r" +
       "ayk9+UpRI2c8/+dfGd1l6ZEs7TJVQgIabfk1IxonQK0Vh3u9tGROLkUzdi\n" +
       "LyqXDgc9UQ8wFGW2s83ABWxUjPML2Scu15J18Sd7ft65/dxxv3UhUN+zIGdW" +
       "bS+seTw0qX8FDa2M\n/LrbvZZpsDolAEGC4XFicZf4TrPwo7sMwTiMTTCSHg" +
       "STDSHI5z4xb5RoCfL1JoAMFQ+mhfNcf6cL\noMiKvhDqvxH8eEW/aD7hnEKl" +
       "mf7HUP1bp+YJI+yMlr1aDaPnDl5tcxxnQbv558OCNMlQ2ISeKCgG\nPK77Yb" +
       "Ng69KAXWXV/KK9G8Z+T/X+xQUULQoqXQIqFtyKSZjkzQhvU3h70kW6coihFs" +
       "01zVniWvz7\noM/8KIwUDMsz31qc+dA9mx2iFxR4Nzc0JOSVvOfIauGIbifk" +
       "myppOS6DHogVs9bVMsWIy+pI4uVo\nyEg01oyqWgF0yybVsGWNHSwyFKt+Xf" +
       "BuvqruPwb5rlX75o9svui0fy3rtPT2jMADMO8aRhXgqsEX\ncQjO60J1RN59" +
       "jvgpMLTyNu8djimxEA64kn4WLgs/PbgifqvpjjHUWqHjO8edBreNDGnxf6Sn" +
       "UnQl\nDQAA");
}
