package benchmarks.micro.socket;

import java.io.*;
import java.net.*;
import benchmarks.micro.BigObject;

public class SocketServer {
    final private static int[] msgSizes = { 100, 10000 };
    final private static int[] sessLens = { 0, 1, 10, 100, 1000 };
    private ServerSocket ss = null;
    
    public SocketServer(int port) throws Exception {
        super();
        ss = new ServerSocket(port);
        int run = 0;
        int id = 0;
        Socket s = null;
        ObjectInputStream ois = null;
        ObjectOutputStream oos = null;
        while (true) {
            System.out.println("Run: " + run++);
            for (int i = 0; i < msgSizes.length; i++) {
                for (int j = 0; j < sessLens.length; j++) {
                    dummyrun();
                    try {
                        s = ss.accept();
                        s.setTcpNoDelay(true);
                        ois = new ObjectInputStream(s.getInputStream());
                        oos = new ObjectOutputStream(s.getOutputStream());
                        for (boolean redo = ois.readBoolean(); redo; ) {
                            oos.writeObject(new BigObject(id++, msgSizes[i] -
                                                            86));
                            oos.flush();
                            redo = ois.readBoolean();
                        }
                    }
                    finally {
                        close(oos, ois, s);
                    }
                }
            }
        }
    }
    
    public static void main(String[] args) throws Exception {
        new SocketServer(Integer.parseInt(args[0]));
    }
    
    void dummyrun() throws Exception {
        Socket s = null;
        ObjectInputStream ois = null;
        ObjectOutputStream oos = null;
        try {
            s = ss.accept();
            s.setTcpNoDelay(true);
            ois = new ObjectInputStream(s.getInputStream());
            oos = new ObjectOutputStream(s.getOutputStream());
            while (ois.readBoolean()) {
                oos.writeObject(new BigObject(-1, 1000));
                oos.flush();
            }
        }
        finally {
            close(oos, ois, s);
        }
    }
    
    private void close(ObjectOutputStream oos, ObjectInputStream ois,
                       Socket s) {
        try {
            if (oos != null) {
                oos.flush();
                oos.close();
            }
            if (ois != null) ois.close();
            if (s != null) s.close();
        }
        catch (IOException ioe) {  }
    }
    
    final public static String jlc$CompilerVersion$jl = "2.2.3";
    final public static long jlc$SourceLastModified$jl = 1209506693702L;
    final public static String jlc$ClassType$jl =
      ("H4sIAAAAAAAAAI1Xa2xURRSe3W233XZLH9ACpbSllAAStvDDRq2JNLUNCwut" +
       "XR5SS5a7d2e3l96X\nd+Zut4hEohEk0cSAr4iQqAmJ4YeBqD80agK+NTH9Af" +
       "6BxGCMiULkh5EYjJ6ZuXcfdxdKk5nOzpwz\n5/Wdc+aevY6qiYW6TUOdzagG" +
       "jdBZE5PImGQRnBpSJUJ2wEZCfmjl7Znvj2xZFkCNE6hR0eNUooo8\nZOgU5+" +
       "gECmtYS2KLDKZSODWBmnWMU3FsKZKqHABCQ59ALUTJ6BK1LUzGMTHULCNsIb" +
       "aJLS7T3Yyh\nsGzohFq2TA2LUNQU2y9lpT6bKmpfTCF0IIaCaQWrKfIkOoR8" +
       "MVSdVqUMELbFXCv6+I19I2wfyOsU\nUNNKSzJ2WaqmFT1FUZeXI29x71YgAN" +
       "YaDdMpIy+qSpdgA7UIlVRJz/TFqaXoGSCtNmyQQlH7HS8F\nolpTkqelDE5Q" +
       "tMRLNyaOgCrE3cJYKGr1kvGbchZq98SsKFqjwfC/x8b+7vZznVNYVpn+1cDU" +
       "6WEa\nx2lsYV3GgvGWHTkR3WN3+BEC4lYPsaAZXPXRzthvn3UJmmUVaEaT+7" +
       "FME/Lt/o7lc4O/hAJMjVrT\nIAqDQonlPKpjzslAzgQstuVvZIcR9/Dz8S/3" +
       "PPMe/t2PaqMoKBuqrelRFMJ6ashZ18A6puhY7I6m\n0wTTKKpS+VbQ4L/BHW" +
       "lFxcwdVbA2JTrF1zkTIVQDwwfjIBJ/9WyiqDFuyNOYAp6z2IqQ/RRtpJhQ\n" +
       "MkkseTIJzpvSJGuaTGqKbBmThBNPenhyTErDjM8HBnZ4k00FZG421BS2EvKZ" +
       "a98eHN76wlF/Hm6O\nfhT1FmRFuKyIkBUploV8Pi5kcakXWVhSLHv+ODfQ9N" +
       "J68qEfBSZQSNE0m0pJFUPWSapqzOBUgnLY\nNRdBnCMLYBlOAkIB7AkVLuIZ" +
       "AW7LWqjHi8RC/kZhJQG85g799+ONxMx5BhoW5EXsdqEahGxa6BZe\nG9+7Zd" +
       "/RngAjmqli0QDS3vlvT8g3jm07f+m7K2sKiAd/lSViOSdLJK/6Y5Yh4xQUqs" +
       "L1r/2z+c/j\n1Q9+4GeoCUF9ohKgCpK90yujJKEG3OLEnOWPofq0YWmSyo7c" +
       "ilJHpyxjprDDgVLP1wvAAbUwwGco\n5kCyhU3ssIlNzQJWzJ8eG3jpu/VscM" +
       "PlT+q/8BdXycaichrHVORccyEcOyyMYf/K62PHX7l+5Ake\nCycYFAVNO6kq" +
       "co7r1+qD2C+skP+RJYtOvLr25GU32AsLtw9aljTLYp07PLf8ja+kt6A2QI4S" +
       "5QDm\nKejLh91bqcYsRYNCkHUq1cud7/56/tr4In9ROV9ZVlGLeURJ5x6rM3" +
       "MgYcXdJHDqi+tWnD00fjUp\nSl1LaUoN67Z2/+mf8NpNYblCtgag6bh+YvN9" +
       "fL2uyEb2u4U63mGJFhnOydhkxY5r2e2wsxTz1owR\n1gBdfGrJp/66cKquW/" +
       "ib8bRzEYEKbixhTMgHPt156tYP9Co3oABsdkdXrlzsLqko5x64lG0Ovn9a\n" +
       "86OaCdTEm7ak012SajMATUDbJUPOZgw1lJyXtlDRLwbyidvhjWORWG9KFZwO" +
       "a0bN1jWeLGqD0Q+j\nwcmiBk8W+ZDJFps4Qw+fVwnMByiIU3QJtKoxLSUrUd" +
       "A9SPjrJ0dRrUYyccAuIeX9mENdgPVcoPem\n/+O2Xl4+qpISEVp6HzLl75SS" +
       "5wc3KmTyf30V0fSw6ZqytdwUP1s/yqbVoHlQxXpGNL8+NkVz+Rv9\ngrwCPo" +
       "dUQ8esXbhnoowrRiT/2IPDXJluFuryOGcbt6uApebssscCU8rX0JbyMCh7nZ" +
       "UyDZQGv87C\n8LjUd5RAoFN4K8qm3orJiLiKqHKmuofs925Agszsd21vKvhF" +
       "ANgpxjwQJdB7BMYCB3oLKkMvUQF6\n+XgNs2mEwY0A0mJYJ3mjvOJCMLphND" +
       "nimiqLS5WL46YPgxA/Ia6JrdxEnT0x+ONCPDS43FyRS1HB\na+2uOy20/E7v" +
       "U15ajzx+M/y8dHGv33HvRopC1DDXqziL1ULd815SCoHG3V0/j/Sfebq88LH1" +
       "zrxX\nGmGshrHd8cr2il20csasFs6ft5JvzktbCqPrLtIqAEh8RJimeVc57G" +
       "c/V5ZSVKVBpeYU6x2uDbCZ\nNZSUx3ifA4O4o0783oyfJyXuTc/nALMpW9Nm" +
       "LVtnvw97dAs5Txvd0U2vpBub0hXlBYqiDQ5td6uR\nyMdRm5o2BddiSXNJlp" +
       "aSRPUyisYC5jna568ML4rKIIr6YcigcPGDnD2AlpR9XouPQLlnbt+aC2bz\n" +
       "N6IxuB9qQfhaStuqWtzaitZB08JphYsOikYnqtxJihbf4ROB9Sy+4Aa8KehP" +
       "AwS99GAK/19M9zZF\ndQU6tvMOLyJ7c/8Dt8zqEz4QAAA=");
}
