//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/macro/rsocket/RServer.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ benchmarks.macro.rsocket.RServer 8888 

package benchmarks.macro.rsocket;

import sj.runtime.*;
import sj.runtime.net.*;

public class RServer 
{
	private protocol body { !<Integer>.?[!<Integer>]* }
	private protocol p { begin.@body }

	public RServer(int port) throws Exception 
	{			
		SJServerSocket ss = SJRServerSocket.create(p, port);
		
		int id = 0;

		SJSocket s = null;
		
		while (true) 			
		{																											
			try (s)
			{					
				s = ss.accept();						
				
				<s>.spawn(new ServerThread(id));
				
				System.out.println("Accepted: " + id++);				
			}
			catch (Exception x)			
			{
				x.printStackTrace();
			}									
		}
	}	

	private class ServerThread extends SJThread
	{
		private final int id; 			
	
		public ServerThread(int id)
		{
			this.id = id;
		}
	
		public void run(@body s) throws SJIOException
		{
			s.send(new Integer(id));

			int v = 0;
		
			s.inwhile()
			{													
				s.send(new Integer(v++));
			}			
		}		
	}

	public static void main(String[] args) throws Exception 
	{
		new RServer(Integer.parseInt(args[0]));
	}		
}
