//$ bin/sjc tests/src/benchmarks/micro/fns2socket/FNS2Client.sj -d tests/classes/benchmarks/micro/fns2socket/
//$ tests/src/benchmarks/micro/fns2socket.sh localhost 8888

import java.io.*;
import java.net.*;

import sj.runtime.*;
import sj.runtime.net.*;
import sj.runtime.net.alt.*;

public class FNS2Client 
{
	private protocol p 
	{
		begin
		.![ 
			?(BigObject)
		]*
	}	

	public FNS2Client(String server, int port, int msgSize, int sessLen) throws Exception 
	{	
		SJServerAddress c = SJServerAddress.create(p, server, port);					
		SJSocket ds = SJFNS2Socket.create(c);			
		SJSocket s = SJFNS2Socket.create(c);					
			
		try (ds) // Dummy run.
		{
			dummyrun(ds);
		}
		finally
		{
		
		}
			
		long timeStarted = -1;		
		long timeFinished = -1;
			
		try (s) // Actual run.
		{
			timeStarted = System.currentTimeMillis();
		
			s.request();					

			int k = 0;

			s.outwhile(k++ < sessLen) 
			{
				BigObject bo = s.receive();
				
				//System.out.println("Received: " + s.receive());
			}									
			
			timeFinished = System.currentTimeMillis();										
		}
		finally 
		{

		}									

		//System.out.println("Object size " + msgSize + ", session length " + sessLen + ": " + (timeFinished - timeStarted) + "ms.");		
		
		System.out.println(timeFinished - timeStarted);	
	}

	public static void main(String args[]) throws Exception 
	{
		new FNS2Client(args[0], Integer.parseInt(args[1]), Integer.parseInt(args[2]), Integer.parseInt(args[3]));
	}

	private void dummyrun(@p ds) throws Exception
	{
		ds.request();				

		int k = 0;

		ds.outwhile(k++ < 1) 
		{
			BigObject bo = ds.receive();		
		}									
	}	
}
