//$ bin/sjc tests/src/benchmarks/micro/fns3socket/FNS3Server.sj -d tests/classes/benchmarks/micro/fns3socket/
//$ bin/sj -cp tests/classes/benchmarks/micro/fns3socket/ FNS3Server 8888

import java.io.*;
import java.net.*;

import sj.types.typeobjects.sesstypes.*;

import sj.runtime.*;
import sj.runtime.net.*;
import sj.runtime.net.alt.*;

public class FNS3Server 
{
	private static final int[] msgSizes = { 100, 10000 };
	private static final int[] sessLens = { 0, 1, 10, 100, 1000 };

	private protocol p 
	{
		begin
		.?[
			!<BigObject>
		]*
	}		

	private ServerSocket dummy = null;
	
	public FNS3Server(int port) throws Exception 
	{					
		this.dummy = new ServerSocket(port + 1);
	
		SJFNS3ServerSocket ss = SJFNS3ServerSocket.create(p, port);
		
		int run = 0;
		int id = 0;		

		while (true) 
		{
			System.out.println("Run: " + run++);
					
			SJFNS3Socket s = null;

			for (int i = 0; i < msgSizes.length; i++)
			{			
				for (int j = 0; j < sessLens.length; j++)
				{				
					dummyrun(port);														
						
					try (s) // Actual run.
					{												
						s = ss.accept();					
						
						s.inwhile() 
						{
							s.send(new BigObject(id++, msgSizes[i] - 86));
						}
					}
					finally 
					{ 

					}
					
					//System.out.println("Served size " + msgSizes[i] + ", length " + sessLens[j] + ".");					
				}
			}				
		}
	}

	public static void main(String[] args) throws Exception 
	{
		new FNS3Server(Integer.parseInt(args[0]));
	}
	
	void dummyrun(int port) throws Exception
	{				
		SJServerAddress c = SJServerAddress.create(p, "foo", 1234);
		SJFNS3Socket bar = SJFNS3Socket.create(c);
			
		Socket s = null;
		ObjectInputStream ois = null;
		ObjectOutputStream oos = null;
	
		try 
		{					
			s = dummy.accept();						

			s.setTcpNoDelay(true);		
			
			ois = new ObjectInputStream(s.getInputStream());
			oos = new ObjectOutputStream(s.getOutputStream());			

			oos.writeObject(p.encodedSJType());
		
			SJType theirs = bar.decodeSJType((String) ois.readObject()); 
	
			if (!bar.protocolType().treeDualtype(theirs))
			{
				throw new IOException("Foo: " + theirs);
			}			
			
			while (ois.readBoolean()) 
			{			
				oos.writeObject(new BigObject(-1, 1000));						
				oos.flush();
			}
		}
		finally 
		{
			try
			{	
				if (oos != null) 
				{				
					oos.flush();						
					oos.close();				
				}	
				if (ois != null) ois.close();
				if (s != null) s.close();
			}			
			catch (IOException ioe) { }			
		}			
	}	
}
