//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/micro/rsocket/RClient.sj -d tests/classes/
//$ tests/src/benchmarks/micro/rsocket/rsocket.sh localhost 8888 100

package benchmarks.micro.rsocket;

import java.io.*;
import java.net.*;

import sj.types.typeobjects.sesstypes.*;

import sj.runtime.*;
import sj.runtime.net.*;

import benchmarks.micro.BigObject;

public class RClient 
{
	private protocol p 
	{
		begin
		.![ 
			?(BigObject)
			//?(int)
		]*
	}	
	
	public RClient(String server, int port, int msgSize, int sessLen) throws Exception 
	{	
		SJServerAddress c = SJServerAddress.create(p, server, port);					
		SJSocket ds = SJRSocket.create(c);			
		SJRSocket s = SJRSocket.create(c);							
			
		long timeStarted = -1;		
		long timeFinished = -1;
		
		try (ds, s) // Actual run.
		{		
			ds.request();							
			
			int k1 = 0;

			ds.outwhile(k1++ < sessLen) 
			{
				BigObject bo = ds.receive();
				//int v = ds.receiveInt();
			}

			boolean foo = true;

			timeStarted = System.nanoTime();
		
			s.request();							
			
			int k = 0;
			
			s.outwhile(k++ < sessLen) 
			{
				BigObject bo = s.receive();
				//int v = s.receiveInt();
			
				/*if (foo) 
				{
					System.out.println("Received: " + bo);								
					foo = false;
				}*/
			}
						
			timeFinished = System.nanoTime();										
		}
		finally 
		{

		}									

		//System.out.println("Object size " + msgSize + ", session length " + sessLen + ": " + Math.round(((float) (timeFinished - timeStarted)) / 1000.0) + "ms.");				
		System.out.println(Math.round(((float) (timeFinished - timeStarted)) / 1000.0));	
	}

	public static void main(String args[]) throws Exception 
	{
		new RClient(args[0], Integer.parseInt(args[1]), Integer.parseInt(args[2]), Integer.parseInt(args[3]));
	}
}
