//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/micro/rsocket/RServer.sj -d tests/classes/
//$ bin/sj -cp tests/classes/ benchmarks.micro.rsocket.RServer 8888

package benchmarks.micro.rsocket;

import java.io.*;
import java.net.*;

import sj.types.typeobjects.sesstypes.*;

import sj.runtime.*;
import sj.runtime.net.*;

import benchmarks.micro.BigObject;

public class RServer 
{
	private static final int[] msgSizes = { 100, 10000 };
	private static final int[] sessLens = { 0, 1, 10, 100, 1000 };

	private protocol p 
	{
		begin
		.?[
			!<BigObject>
			//!<int>
		]*
	}		

	private ServerSocket dummy = null;
	
	public RServer(int port) throws Exception 
	{					
		this.dummy = new ServerSocket(port + 1);
	
		SJRServerSocket ss = SJRServerSocket.create(p, port);
		
		int run = 0;
		int id = 0;		

		while (true) 
		{
			System.out.println("Run: " + run++);
			
			SJRSocket ds = null;
			SJRSocket s = null;

			for (int i = 0; i < msgSizes.length; i++)
			{			
				for (int j = 0; j < sessLens.length; j++)
				{															
					try (ds, s) 
					{												
						ds = ss.accept();	// Dummy run.
						
						ds.inwhile() 
						{
							ds.send(new BigObject(-1, msgSizes[i] - 86));
							//ds.send(123);
						}
						
						s = ss.accept(); // Actual run.
						
						s.inwhile() 
						{
							s.send(new BigObject(id++, msgSizes[i] - 86));
							//s.send(id++);
						}
					}
					finally 
					{ 

					}
					
					//System.out.println("Served size " + msgSizes[i] + ", length " + sessLens[j] + ".");	
				}
			}				
		}
	}

	public static void main(String[] args) throws Exception 
	{
		new RServer(Integer.parseInt(args[0]));
	}
}
