//$ bin/sjc -cp tests/classes/ tests/src/benchmarks/ticketagency/fsocket/FCustomer.sj -d tests/classes/
//$ tests/src/benchmarks/ticketagency/fsocket/ticketagency.sh localhost 9999 100
//$ bin/sj -cp tests/classes/ benchmarks.ticketagency.fsocket.FCustomer localhost 9999 100

package benchmarks.ticketagency.fsocket;

import java.util.Date;

import sj.runtime.*;
import sj.runtime.net.*;

import benchmarks.ticketagency.Address;

class FCustomer 
{
	private static protocol p_ca 
	{
		begin
		.![
			!<String>
			.?(Double)
		]*
		.!{
				ACCEPT: !<Address>.?(Date)
			, FEJECT:
		}
	}

	FCustomer(String addr_a, int port_a, int redo) throws Exception
	{
		int x = 0;

		while (x++ < redo)
		{
			SJServerAddress c_ca = SJServerAddress.create(p_ca, addr_a, port_a);
			SJSocket s_ca = SJFSocket.create(c_ca);	

			long timeStarted = -1;		
			long timeFinished = -1;		

			try (s_ca)
			{
				timeStarted = System.nanoTime();
			
				s_ca.request();

				int i = 0;

				s_ca.outwhile(i++ < 10) 
				{
					s_ca.send("travel");

					Double cost = s_ca.receive();				
				}

				s_ca.outbranch(ACCEPT) 
				{
					s_ca.send(new Address("address"));

					//System.out.println("Received dispatch date: " + (Date) s_ca.receive());
					Date d = s_ca.receive();
				}
				
				timeFinished = System.nanoTime();
			}
			finally
			{
				System.out.println((timeFinished - timeStarted) / 1000);
			}
		}
	}

	public static void main(String[] args) throws Exception
	{
		new FCustomer(args[0], Integer.parseInt(args[1]), Integer.parseInt(args[2]));
	}
}
