//$ bin/sjc tests/src/compiler/recursion/AServer.sj -d tests/classes/compiler/recursion/
//$ bin/sj -cp tests/classes/compiler/recursion/ AServer 7777 8888

import java.util.*;

import sj.runtime.*;
import sj.runtime.net.*;

public class AServer
{	
	private protocol p_meth2
	{ 
		rec meth2[
			!<int>			
			.?{
				REDOX: #meth1,
				REDOY: #meth2,
				QUIT: //?(String)
			}
		]
	}

	private protocol p_meth1
	{ 
		rec meth1[
			!<int>
			.@p_meth2
		]
	}

	private protocol p { begin.@p_meth1 }	

	public AServer(int port) throws Exception
	{
		//BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		//try { br.readLine(); } catch(IOException ioe) { }	
	
		SJServerSocket ss = null;
		SJSocket s = null;
		
		try
		{
			ss = SJFServerSocket.create(p, port);

			while(true)		
			{
				try (s)
				{		
					s = ss.accept();											

					int i = 0; 

					//meth(s, i);					
					meth1(s, i);					
				}
				finally
				{

				}
			}
		}
		finally
		{
			if (ss != null) ss.close();
		}		
	}

	private	void meth(@p_meth1 s, int i) throws SJIOException
	{
		s.recursion(meth1)
		{
			s.send(i);

			s.recursion(meth2)
			{
				s.send(i++);											

				s.inbranch()
				{
					case REDOX:
					{							
						s.recurse(meth1);
					}
					case REDOY:
					{
						s.recurse(meth2);
					}								
					case QUIT:
					{
						//System.out.println("Received: " + (String) s.receive());
					}
				}
			}
		}
	}
	
	private sessrec void meth1(@p_meth1 s, int i) throws SJIOException
	{
		s.send(i);
		
		meth2(s, i);
	}

	private sessrec void meth2(@p_meth2 s, int i) throws SJIOException
	{
		s.send(i++);											
							
		s.inbranch()
		{
			case REDOX:
			{
				meth1(s, i);
			}
			case REDOY:
			{
				meth2(s, i);
			}								
			case QUIT:
			{

			}
		}					
	}
	
	public static void main(String[] args) throws Exception
	{			
		new AServer(Integer.parseInt(args[0]));
	}	
}
